Distribute all lib/* source files through EXTRA_DIST.
[gnulib.git] / gnulib-tool
index 06f0458..f196451 100755 (executable)
 
 progname=$0
 package=gnulib
-cvsdatestamp='$Date: 2006-09-01 15:17:11 $'
+cvsdatestamp='$Date: 2006-10-12 12:33:50 $'
 last_checkin_date=`echo "$cvsdatestamp" | sed -e 's,^\$[D]ate: ,,'`
 version=`echo "$last_checkin_date" | sed -e 's/ .*$//' -e 's,/,-,g'`
+nl='
+'
 
 # You can set AUTOCONFPATH to empty if autoconf 2.57 is already in your PATH.
 AUTOCONFPATH=
@@ -38,11 +40,17 @@ AUTOCONFPATH=
 # You can set AUTOMAKEPATH to empty if automake 1.9.x is already in your PATH.
 AUTOMAKEPATH=
 
+# You can set GETTEXTPATH to empty if autopoint 0.15 is already in your PATH.
+GETTEXTPATH=
+
 # If you didn't set AUTOCONFPATH and AUTOMAKEPATH, you can also set the
-# variables AUTOCONF, ACLOCAL, AUTOMAKE, AUTORECONF individually.
+# variables AUTOCONF, AUTOHEADER, ACLOCAL, AUTOMAKE, AUTORECONF individually.
 if test -z "${AUTOCONF}" || test -n "${AUTOCONFPATH}"; then
   AUTOCONF="${AUTOCONFPATH}autoconf"
 fi
+if test -z "${AUTOHEADER}" || test -n "${AUTOCONFPATH}"; then
+  AUTOHEADER="${AUTOCONFPATH}autoheader"
+fi
 if test -z "${ACLOCAL}" || test -n "${AUTOMAKEPATH}"; then
   ACLOCAL="${AUTOMAKEPATH}aclocal"
 fi
@@ -53,6 +61,11 @@ if test -z "${AUTORECONF}" || test -n "${AUTOCONFPATH}"; then
   AUTORECONF="${AUTOCONFPATH}autoreconf"
 fi
 
+# If you didn't set GETTEXTPATH, you can also set the variable AUTOPOINT.
+if test -z "${AUTOPOINT}" || test -n "${GETTEXTPATH}"; then
+  AUTOPOINT="${GETTEXTPATH}autopoint"
+fi
+
 # GNU sort is needed. Set SORT to its location (not needed if it's called
 # 'sort' and already in the PATH).
 if test -z "$SORT"; then
@@ -67,7 +80,7 @@ func_usage ()
 Usage: gnulib-tool --list
        gnulib-tool --import [module1 ... moduleN]
        gnulib-tool --update
-       gnulib-tool --create-testdir --dir=directory module1 ... moduleN
+       gnulib-tool --create-testdir --dir=directory [module1 ... moduleN]
        gnulib-tool --create-megatestdir --dir=directory [module1 ... moduleN]
        gnulib-tool --test --dir=directory module1 ... moduleN
        gnulib-tool --megatest --dir=directory [module1 ... moduleN]
@@ -155,11 +168,12 @@ Report bugs to <bug-gnulib@gnu.org>."
 func_version ()
 {
   year=`echo "$last_checkin_date" | sed -e 's,/.*$,,'`
-  echo "$progname (GNU $package) $version"
-  echo "Copyright (C) $year Free Software Foundation, Inc.
+  echo "\
+$progname (GNU $package) $version
+Copyright (C) $year Free Software Foundation, Inc.
 This is free software; see the source for copying conditions.  There is NO
-warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE."
-  echo "Written by" "Bruno Haible" "and" "Simon Josefsson"
+warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+Written by" "Bruno Haible" "and" "Simon Josefsson"
 }
 
 # func_emit_copyright_notice
@@ -177,6 +191,13 @@ func_emit_copyright_notice ()
   echo "# Generated by gnulib-tool."
 }
 
+# func_exit STATUS
+# exit with status
+func_exit ()
+{
+  (exit $1); exit $1
+}
+
 # func_tmpdir
 # creates a temporary directory.
 # Sets variable
@@ -204,17 +225,33 @@ func_tmpdir ()
   } ||
   {
     echo "$0: cannot create a temporary directory in $TMPDIR" >&2
-    { (exit 1); exit 1; }
+    func_exit 1
   }
 }
 
+# func_append var value
+# appends the given value to the shell variable var.
+if ( foo=bar; foo+=baz && test "$foo" = barbaz ) >/dev/null 2>&1; then
+  # Use bash's += operator. It reduces complexity of appending repeatedly to
+  # a single variable from O(n^2) to O(n).
+  func_append ()
+  {
+    eval "$1+=\"\$2\""
+  }
+else
+  func_append ()
+  {
+    eval "$1=\"\$$1\$2\""
+  }
+fi
+
 # func_fatal_error message
 # outputs to stderr a fatal error message, and terminates the program.
 func_fatal_error ()
 {
   echo "gnulib-tool: *** $1" 1>&2
   echo "gnulib-tool: *** Stop." 1>&2
-  exit 1
+  func_exit 1
 }
 
 # func_readlink SYMLINK
@@ -503,10 +540,11 @@ func_relconcat ()
         if test $# = 0; then
           func_fatal_error "missing argument for --avoid"
         fi
-        avoidlist="$avoidlist $1"
+        func_append avoidlist " $1"
         shift ;;
       --avoid=* )
-        avoidlist="$avoidlist "`echo "X$1" | sed -e 's/^X--avoid=//'`
+        arg=`echo "X$1" | sed -e 's/^X--avoid=//'`
+        func_append avoidlist " $arg"
         shift ;;
       --lgpl )
         lgpl=true
@@ -548,10 +586,10 @@ func_relconcat ()
         shift ;;
       --help | --hel | --he | --h )
         func_usage
-        exit 0 ;;
+        func_exit $? ;;
       --version | --versio | --versi | --vers | --ver | --ve | --v )
         func_version
-        exit 0 ;;
+        func_exit $? ;;
       -- )
         # Stop option processing
         shift
@@ -559,7 +597,7 @@ func_relconcat ()
       -* )
         echo "gnulib-tool: unknown option $1" 1>&2
         echo "Try 'gnulib-tool --help' for more information." 1>&2
-        exit 1 ;;
+        func_exit 1 ;;
       * )
         break ;;
     esac
@@ -571,7 +609,7 @@ func_relconcat ()
       echo "Try 'gnulib-tool --help' for more information." 1>&2
       echo "If you really want to modify the gnulib configuration of your project," 1>&2
       echo "you need to use 'gnulib --import' - at your own risk!" 1>&2
-      exit 1
+      func_exit 1
     fi
     if test -n "$local_gnulib_dir" || test -n "$supplied_libname" \
        || test -n "$sourcebase" || test -n "$m4base" \
@@ -582,7 +620,7 @@ func_relconcat ()
       echo "Try 'gnulib-tool --help' for more information." 1>&2
       echo "If you really want to modify the gnulib configuration of your project," 1>&2
       echo "you need to use 'gnulib --import' - at your own risk!" 1>&2
-      exit 1
+      func_exit 1
     fi
     do_changelog=false
   fi
@@ -625,7 +663,7 @@ func_relconcat ()
       }'
     eval `sed -n -e "$my_sed_traces" < "$configure_ac"`
     if test -n "$prereqs"; then
-      autoconf_minversion=`for version in $prereqs; do echo $version; done | $SORT -g | uniq | tail -1`
+      autoconf_minversion=`for version in $prereqs; do echo $version; done | $SORT -g -u | tail -1`
     fi
   fi
   if test -z "$autoconf_minversion"; then
@@ -685,7 +723,16 @@ done
 gnulib_dir=`echo "$self_abspathname" | sed -e 's,/[^/]*$,,'`
 
 func_tmpdir
-trap 'rm -rf "$tmp"' 0 1 2 3 15
+trap 'exit_status=$?
+      if test "$signal" != 0; then
+        echo "caught signal $signal" >&2
+      fi
+      rm -rf "$tmp"
+      exit $exit_status' 0
+for signal in 1 2 3 13 15; do
+  trap '{ signal='$signal'; func_exit 1; }' $signal
+done
+signal=0
 
 # func_lookup_file file
 # looks up a file in $local_gnulib_dir or $gnulib_dir, or combines it through
@@ -737,8 +784,7 @@ func_all_modules ()
   } \
       | sed -e '/^CVS$/d' -e '/^ChangeLog$/d' -e '/^COPYING$/d' -e '/^README$/d' -e '/^TEMPLATE$/d' -e '/^TEMPLATE-TESTS$/d' -e '/~$/d' \
       | sed -e '/-tests$/d' \
-      | LC_ALL=C sort \
-      | LC_ALL=C uniq
+      | LC_ALL=C sort -u
 }
 
 # func_verify_module
@@ -924,49 +970,50 @@ func_acceptable ()
 # - modules         list of specified modules
 # - inctests        true if tests should be included, blank otherwise
 # - avoidlist       list of modules to avoid
+# - tmp             pathname of a temporary directory
 # Output:
 # - modules         list of modules, including dependencies
 func_modules_transitive_closure ()
 {
-  while true; do
-    xmodules=
-    for module in $modules; do
+  # In order to process every module only once (for speed), process an "input
+  # list" of modules, producing an "output list" of modules. During each round,
+  # more modules can be queued in the input list. Once a module on the input
+  # list has been processed, it is added to the "handled list", so we can avoid
+  # to process it again.
+  handledmodules=
+  inmodules="$modules"
+  outmodules=
+  while test -n "$inmodules"; do
+    inmodules_this_round="$inmodules"
+    inmodules=                    # Accumulator, queue for next round
+    for module in $inmodules_this_round; do
       func_verify_module
       if test -n "$module"; then
-        # Duplicate dependencies are harmless, but Jim wants a warning.
-        duplicated_deps=`func_get_dependencies $module | LC_ALL=C sort | LC_ALL=C uniq -d`
-        if test -n "$duplicated_deps"; then
-          echo "warning: module $module has duplicated dependencies: "`echo $duplicated_deps` 1>&2
-        fi
         if func_acceptable $module; then
-          xmodules="$xmodules $module"
-          for depmodule in `func_get_dependencies $module`; do
-            if func_acceptable $depmodule; then
-              xmodules="$xmodules $depmodule"
-            fi
-          done
+          func_append outmodules " $module"
+          deps=`func_get_dependencies $module`
+          # Duplicate dependencies are harmless, but Jim wants a warning.
+          duplicated_deps=`echo "$deps" | LC_ALL=C sort | LC_ALL=C uniq -d`
+          if test -n "$duplicated_deps"; then
+            echo "warning: module $module has duplicated dependencies: "`echo $duplicated_deps` 1>&2
+          fi
+          func_append inmodules " $deps"
           if test -n "$inctests"; then
             testsmodule=`func_get_tests_module $module`
             if test -n "$testsmodule"; then
-              if func_acceptable $testsmodule; then
-                xmodules="$xmodules $testsmodule"
-                for depmodule in `func_get_dependencies $testsmodule`; do
-                  if func_acceptable $depmodule; then
-                    xmodules="$xmodules $depmodule"
-                  fi
-                done
-              fi
+              func_append inmodules " $testsmodule"
             fi
           fi
         fi
       fi
     done
-    xmodules=`for m in $xmodules; do echo $m; done | LC_ALL=C sort | LC_ALL=C uniq`
-    if test "$xmodules" = "$modules"; then
-      break
-    fi
-    modules="$xmodules"
+    handledmodules=`for m in $handledmodules $inmodules_this_round; do echo $m; done | LC_ALL=C sort -u`
+    # Remove $handledmodules from $inmodules.
+    for m in $inmodules; do echo $m; done | LC_ALL=C sort -u > "$tmp"/queued-modules
+    inmodules=`echo "$handledmodules" | LC_ALL=C join -v 2 - "$tmp"/queued-modules`
   done
+  modules=`for m in $outmodules; do echo $m; done | LC_ALL=C sort -u`
+  rm -f "$tmp"/queued-modules
 }
 
 # func_modules_add_dummy
@@ -1000,7 +1047,7 @@ ba
   done
   # Add the dummy module, to make sure the library will be non-empty.
   if test -z "$have_lib_SOURCES"; then
-    modules="$modules dummy"
+    func_append modules " dummy"
   fi
 }
 
@@ -1016,10 +1063,11 @@ func_modules_to_filelist ()
   for module in $modules; do
     func_verify_module
     if test -n "$module"; then
-      files="$files "`func_get_filelist $module`
+      fs=`func_get_filelist $module`
+      func_append files " $fs"
     fi
   done
-  files=`for f in $files; do echo $f; done | LC_ALL=C sort | LC_ALL=C uniq`
+  files=`for f in $files; do echo $f; done | LC_ALL=C sort -u`
 }
 
 # func_emit_lib_Makefile_am
@@ -1030,6 +1078,7 @@ func_modules_to_filelist ()
 # - libname         library name
 # - makefile_name   from --makefile-name
 # - libtool         true if libtool will be used, false or blank otherwise
+# - macro_prefix    prefix of gl_LIBOBJS macros to use
 # - actioncmd       (optional) command that will reproduce this invocation
 func_emit_lib_Makefile_am ()
 {
@@ -1043,10 +1092,13 @@ func_emit_lib_Makefile_am ()
   if test "$libtool" = true; then
     libext=la
     perhapsLT=LT
+    sed_eliminate_LDFLAGS=
   else
     libext=a
     perhapsLT=
+    sed_eliminate_LDFLAGS='/^lib_LDFLAGS[       ]*+=/d'
   fi
+  echo "## DO NOT EDIT! GENERATED AUTOMATICALLY!"
   echo "## Process this file with automake to produce Makefile.in."
   func_emit_copyright_notice
   if test -n "$actioncmd"; then
@@ -1054,8 +1106,7 @@ func_emit_lib_Makefile_am ()
   fi
   echo
   if test -z "$makefile_name"; then
-    # No need to generate dependencies since the sources are in gnulib, not here.
-    echo "AUTOMAKE_OPTIONS = 1.5 gnits no-dependencies"
+    echo "AUTOMAKE_OPTIONS = 1.5 gnits"
   fi
   echo
   (
@@ -1066,11 +1117,13 @@ func_emit_lib_Makefile_am ()
           func_get_automake_snippet "$module" |
             sed -e 's,lib_LIBRARIES,lib%_LIBRARIES,g' \
                 -e 's,lib_LTLIBRARIES,lib%_LTLIBRARIES,g' |
+            sed -e "$sed_eliminate_LDFLAGS" |
             sed -e 's,lib_\([A-Z][A-Z]*\),'"${libname}_${libext}"'_\1,g' |
             sed -e 's,lib%_LIBRARIES,lib_LIBRARIES,g' \
                 -e 's,lib%_LTLIBRARIES,lib_LTLIBRARIES,g'
           if test "$module" = 'alloca'; then
             echo "${libname}_${libext}_LIBADD += @${perhapsLT}ALLOCA@"
+            echo "${libname}_${libext}_DEPENDENCIES += @${perhapsLT}ALLOCA@"
           fi
         } > amsnippet.tmp
         # Skip the contents if its entirely empty.
@@ -1095,9 +1148,17 @@ func_emit_lib_Makefile_am ()
   fi
   echo
   echo "${libname}_${libext}_SOURCES ="
-  echo "${libname}_${libext}_LIBADD = @${perhapsLT}LIBOBJS@"
+  # Here we use $(LIBOBJS), not @LIBOBJS@. The value is the same. However,
+  # automake during its analyses looks for $(LIBOBJS), not for @LIBOBJS@.
+  echo "${libname}_${libext}_LIBADD = \$(${macro_prefix}_${perhapsLT}LIBOBJS)"
+  echo "${libname}_${libext}_DEPENDENCIES = \$(${macro_prefix}_${perhapsLT}LIBOBJS)"
+  if test "$libtool" = true; then
+    echo "${libname}_${libext}_LDFLAGS = \$(AM_LDFLAGS)"
+  fi
   if test -z "$makefile_name"; then
     echo "noinst_HEADERS ="
+    # Automake versions < 1.9b create an empty pkgdatadir at installation time
+    # if you specify pkgdata_DATA to empty. This is a workaround.
     if grep '^pkgdata_DATA *+=' allsnippets.tmp > /dev/null; then
       echo "pkgdata_DATA ="
     fi
@@ -1145,7 +1206,15 @@ func_emit_tests_Makefile_am ()
   else
     libext=a
   fi
+  if test "$libtool" = true; then
+    libext=la
+    sed_eliminate_LDFLAGS=
+  else
+    libext=a
+    sed_eliminate_LDFLAGS='/^lib_LDFLAGS[       ]*+=/d'
+  fi
   testsbase_inverse=`echo "$testsbase" | sed -e 's,/$,,' | sed -e 's,[^/][^/]*,..,g'`
+  echo "## DO NOT EDIT! GENERATED AUTOMATICALLY!"
   echo "## Process this file with automake to produce Makefile.in."
   func_emit_copyright_notice
   echo
@@ -1158,7 +1227,15 @@ func_emit_tests_Makefile_am ()
     for module in $modules; do
       func_verify_tests_module
       if test -n "$module"; then
-        func_get_automake_snippet "$module" > amsnippet.tmp
+        {
+          func_get_automake_snippet "$module" |
+            sed -e 's,lib_LIBRARIES,lib%_LIBRARIES,g' \
+                -e 's,lib_LTLIBRARIES,lib%_LTLIBRARIES,g' |
+            sed -e "$sed_eliminate_LDFLAGS" |
+            sed -e 's,lib_\([A-Z][A-Z]*\),'"${libname}_${libext}"'_\1,g' |
+            sed -e 's,lib%_LIBRARIES,lib_LIBRARIES,g' \
+                -e 's,lib%_LTLIBRARIES,lib_LTLIBRARIES,g'
+        } > amsnippet.tmp
         # Skip the contents if its entirely empty.
         if grep '[^     ]' amsnippet.tmp > /dev/null ; then
           echo "## begin gnulib module $module"
@@ -1214,6 +1291,56 @@ func_emit_tests_Makefile_am ()
   rm -f allsnippets.tmp
 }
 
+# func_emit_initmacro_start
+# emits the first few statements of the gl_INIT macro to standard output.
+# - macro_prefix    prefix of gl_EARLY, gl_INIT macros to use
+func_emit_initmacro_start ()
+{
+  echo "  m4_pushdef([AC_LIBOBJ], m4_defn([${macro_prefix}_LIBOBJ]))"
+  echo "  m4_pushdef([AC_REPLACE_FUNCS], m4_defn([${macro_prefix}_REPLACE_FUNCS]))"
+}
+
+# func_emit_initmacro_end
+# emits the last few statements of the gl_INIT macro to standard output.
+# - macro_prefix    prefix of gl_EARLY, gl_INIT macros to use
+func_emit_initmacro_end ()
+{
+  echo "  m4_popdef([AC_REPLACE_FUNCS])"
+  echo "  m4_popdef([AC_LIBOBJ])"
+  echo "  AC_CONFIG_COMMANDS_PRE(["
+  echo "    ${macro_prefix}_libobjs="
+  echo "    ${macro_prefix}_ltlibobjs="
+  echo "    if test -n \"\$${macro_prefix}_LIBOBJS\"; then"
+  echo "      for i in \$${macro_prefix}_LIBOBJS; do"
+  echo "        # Remove the extension."
+  echo "        sed_drop_objext='s/\\.o\$//;s/\\.obj\$//'"
+  echo "        i=\`echo \"\$i\" | sed \"\$sed_drop_objext\"\`"
+  echo "        ${macro_prefix}_libobjs=\"\$${macro_prefix}_libobjs \$i.\$ac_objext\""
+  echo "        ${macro_prefix}_ltlibobjs=\"\$${macro_prefix}_ltlibobjs \$i.lo\""
+  echo "      done"
+  echo "    fi"
+  echo "    AC_SUBST([${macro_prefix}_LIBOBJS], [\$${macro_prefix}_libobjs])"
+  echo "    AC_SUBST([${macro_prefix}_LTLIBOBJS], [\$${macro_prefix}_ltlibobjs])"
+  echo "  ])"
+}
+
+# func_emit_initmacro_done
+# emits a few statements after the gl_INIT macro to standard output.
+# - macro_prefix    prefix of gl_EARLY, gl_INIT macros to use
+func_emit_initmacro_done ()
+{
+  echo
+  echo "# Like AC_LIBOBJ, except that the module name goes"
+  echo "# into ${macro_prefix}_LIBOBJS instead of into LIBOBJS."
+  echo "AC_DEFUN([${macro_prefix}_LIBOBJ],"
+  echo "  [${macro_prefix}_LIBOBJS=\"\$${macro_prefix}_LIBOBJS \$1.\$ac_objext\"])"
+  echo
+  echo "# Like AC_REPLACE_FUNCS, except that the module name goes"
+  echo "# into ${macro_prefix}_LIBOBJS instead of into LIBOBJS."
+  echo "AC_DEFUN([${macro_prefix}_REPLACE_FUNCS],"
+  echo "  [AC_CHECK_FUNCS([\$1], , [${macro_prefix}_LIBOBJ(\$ac_func)])])"
+}
+
 # func_import modules
 # Uses also the variables
 # - destdir         target directory
@@ -1398,7 +1525,7 @@ func_import ()
   fi
 
   # Canonicalize the list of specified modules.
-  specified_modules=`for m in $specified_modules; do echo $m; done | LC_ALL=C sort | LC_ALL=C uniq`
+  specified_modules=`for m in $specified_modules; do echo $m; done | LC_ALL=C sort -u`
 
   # Determine final module list.
   modules="$specified_modules"
@@ -1452,7 +1579,7 @@ func_import ()
   new_files="$files m4/gnulib-tool.m4"
   old_files="$cached_files"
   if test -f "$destdir"/$m4base/gnulib-tool.m4; then
-    old_files="$old_files m4/gnulib-tool.m4"
+    func_append old_files " m4/gnulib-tool.m4"
   fi
 
   # Create directories.
@@ -1521,28 +1648,30 @@ func_import ()
 
   # Copy files or make symbolic links. Remove obsolete files.
   delimiter='  '
-  for f in $old_files; do
-    case "$f" in
-      build-aux/*) g=`echo "$f" | sed -e "s,^build-aux/,$auxdir/,"` ;;
-      doc/*) g=`echo "$f" | sed -e "s,^doc/,$cached_docbase/,"` ;;
-      lib/*) g=`echo "$f" | sed -e "s,^lib/,$cached_sourcebase/,"` ;;
-      m4/*) g=`echo "$f" | sed -e "s,^m4/,$cached_m4base/,"` ;;
-      tests/*) g=`echo "$f" | sed -e "s,^tests/,$cached_testsbase/,"` ;;
-      *) g="$f" ;;
-    esac
-    echo "$g""$delimiter""$f"
-  done | LC_ALL=C sort > "$tmp"/old-files
-  for f in $new_files; do
-    case "$f" in
-      build-aux/*) g=`echo "$f" | sed -e "s,^build-aux/,$auxdir/,"` ;;
-      doc/*) g=`echo "$f" | sed -e "s,^doc/,$docbase/,"` ;;
-      lib/*) g=`echo "$f" | sed -e "s,^lib/,$sourcebase/,"` ;;
-      m4/*) g=`echo "$f" | sed -e "s,^m4/,$m4base/,"` ;;
-      tests/*) g=`echo "$f" | sed -e "s,^tests/,$testsbase/,"` ;;
-      *) g="$f" ;;
-    esac
-    echo "$g""$delimiter""$f"
-  done | LC_ALL=C sort > "$tmp"/new-files
+  sed_rewrite_old_files="\
+    s,^build-aux/,$auxdir/,
+    s,^doc/,$cached_docbase/,
+    s,^lib/,$cached_sourcebase/,
+    s,^m4/,$cached_m4base/,
+    s,^tests/,$cached_testsbase/,"
+  sed_rewrite_new_files="\
+    s,^build-aux/,$auxdir/,
+    s,^doc/,$docbase/,
+    s,^lib/,$sourcebase/,
+    s,^m4/,$m4base/,
+    s,^tests/,$testsbase/,"
+  # Construct a table with 2 columns: rewritten-file-name original-file-name,
+  # representing the files according to the last gnulib-tool invocation.
+  for f in $old_files; do echo $f; done \
+    | sed -e "s,^.*\$,&$delimiter&," -e "$sed_rewrite_old_files" \
+    | LC_ALL=C sort \
+    > "$tmp"/old-files
+  # Construct a table with 2 columns: rewritten-file-name original-file-name,
+  # representing the files after this gnulib-tool invocation.
+  for f in $new_files; do echo $f; done \
+    | sed -e "s,^.*\$,&$delimiter&," -e "$sed_rewrite_new_files" \
+    | LC_ALL=C sort \
+    > "$tmp"/new-files
   # First the files that are in old-files, but not in new-files:
   sed_take_first_column='s,'"$delimiter"'.*,,'
   for g in `LC_ALL=C join -t"$delimiter" -v1 "$tmp"/old-files "$tmp"/new-files | sed -e "$sed_take_first_column"`; do
@@ -1557,7 +1686,10 @@ func_import ()
     fi
   done
   # func_add_or_update handles a file that ought to be present afterwards.
-  # Uses parameters f, g, already_present.
+  # Uses parameters
+  # - f             the original file name
+  # - g             the rewritten file name
+  # - already_present  nonempty if the file already exists, empty otherwise
   func_add_or_update ()
   {
     func_dest_tmpfilename "$g"
@@ -1619,58 +1751,58 @@ func_import ()
   # Then the files that are in new-files, but not in old-files:
   sed_take_last_column='s,^.*'"$delimiter"',,'
   already_present=
-  for f in `LC_ALL=C join -t"$delimiter" -v2 "$tmp"/old-files "$tmp"/new-files | sed -e "$sed_take_last_column"`; do
-    case "$f" in
-      build-aux/*) g=`echo "$f" | sed -e "s,^build-aux/,$auxdir/,"` ;;
-      doc/*) g=`echo "$f" | sed -e "s,^doc/,$docbase/,"` ;;
-      lib/*) g=`echo "$f" | sed -e "s,^lib/,$sourcebase/,"` ;;
-      m4/*) g=`echo "$f" | sed -e "s,^m4/,$m4base/,"` ;;
-      tests/*) g=`echo "$f" | sed -e "s,^tests/,$testsbase/,"` ;;
-      *) g="$f" ;;
-    esac
-    func_add_or_update
-  done
+  LC_ALL=C join -t"$delimiter" -v2 "$tmp"/old-files "$tmp"/new-files \
+    | sed -e "$sed_take_last_column" \
+    | sed -e "s,^.*\$,&$delimiter&," -e "$sed_rewrite_new_files" > "$tmp"/added-files
+  { # Rearrange file descriptors. Needed because "while ... done < ..."
+    # constructs are executed in a subshell e.g. by Solaris 10 /bin/sh.
+    exec 5<&0 < "$tmp"/added-files
+    while read g f; do
+      func_add_or_update
+    done
+    exec 0<&5 5<&-
+  }
   # Then the files that are in new-files and in old-files:
   already_present=true
-  for f in `LC_ALL=C join -t"$delimiter" "$tmp"/old-files "$tmp"/new-files | sed -e "$sed_take_last_column"`; do
-    case "$f" in
-      build-aux/*) g=`echo "$f" | sed -e "s,^build-aux/,$auxdir/,"` ;;
-      doc/*) g=`echo "$f" | sed -e "s,^doc/,$docbase/,"` ;;
-      lib/*) g=`echo "$f" | sed -e "s,^lib/,$sourcebase/,"` ;;
-      m4/*) g=`echo "$f" | sed -e "s,^m4/,$m4base/,"` ;;
-      tests/*) g=`echo "$f" | sed -e "s,^tests/,$testsbase/,"` ;;
-      *) g="$f" ;;
-    esac
-    func_add_or_update
-  done
+  LC_ALL=C join -t"$delimiter" "$tmp"/old-files "$tmp"/new-files \
+    | sed -e "$sed_take_last_column" \
+    | sed -e "s,^.*\$,&$delimiter&," -e "$sed_rewrite_new_files" > "$tmp"/kept-files
+  { # Rearrange file descriptors. Needed because "while ... done < ..."
+    # constructs are executed in a subshell e.g. by Solaris 10 /bin/sh.
+    exec 5<&0 < "$tmp"/kept-files
+    while read g f; do
+      func_add_or_update
+    done
+    exec 0<&5 5<&-
+  }
 
   # Command-line invocation printed in a comment in generated gnulib-cache.m4.
   actioncmd="gnulib-tool --import"
-  actioncmd="$actioncmd --dir=$destdir"
+  func_append actioncmd " --dir=$destdir"
   if test -n "$local_gnulib_dir"; then
-    actioncmd="$actioncmd --local-dir=$local_gnulib_dir"
+    func_append actioncmd " --local-dir=$local_gnulib_dir"
   fi
-  actioncmd="$actioncmd --lib=$libname"
-  actioncmd="$actioncmd --source-base=$sourcebase"
-  actioncmd="$actioncmd --m4-base=$m4base"
-  actioncmd="$actioncmd --doc-base=$docbase"
-  actioncmd="$actioncmd --aux-dir=$auxdir"
+  func_append actioncmd " --lib=$libname"
+  func_append actioncmd " --source-base=$sourcebase"
+  func_append actioncmd " --m4-base=$m4base"
+  func_append actioncmd " --doc-base=$docbase"
+  func_append actioncmd " --aux-dir=$auxdir"
   for module in $avoidlist; do
-    actioncmd="$actioncmd --avoid=$module"
+    func_append actioncmd " --avoid=$module"
   done
   if test -n "$lgpl"; then
-    actioncmd="$actioncmd --lgpl"
+    func_append actioncmd " --lgpl"
   fi
   if test -n "$makefile_name"; then
-    actioncmd="$actioncmd --makefile_name=$makefile_name"
+    func_append actioncmd " --makefile_name=$makefile_name"
   fi
   if test "$libtool" = true; then
-    actioncmd="$actioncmd --libtool"
+    func_append actioncmd " --libtool"
   else
-    actioncmd="$actioncmd --no-libtool"
+    func_append actioncmd " --no-libtool"
   fi
-  actioncmd="$actioncmd --macro-prefix=$macro_prefix"
-  actioncmd="$actioncmd `echo $specified_modules`"
+  func_append actioncmd " --macro-prefix=$macro_prefix"
+  func_append actioncmd " `echo $specified_modules`"
 
   # Default the makefile name to Makefile.am.
   if test -n "$makefile_name"; then
@@ -1780,6 +1912,7 @@ func_import ()
   # Create m4/gnulib-comp.m4.
   func_dest_tmpfilename $m4base/gnulib-comp.m4
   (
+    echo "# DO NOT EDIT! GENERATED AUTOMATICALLY!"
     func_emit_copyright_notice
     echo "#"
     echo "# This file represents the compiled summary of the specification in"
@@ -1794,7 +1927,9 @@ func_import ()
     echo "AC_DEFUN([${macro_prefix}_EARLY],"
     echo "["
     echo "  m4_pattern_forbid([^gl_[A-Z]])dnl the gnulib macro namespace"
-    echo "  m4_pattern_allow([^gl_ES$])dnl a valid locale name"
+    echo "  m4_pattern_allow([^gl_ES\$])dnl a valid locale name"
+    echo "  m4_pattern_allow([^gl_LIBOBJS\$])dnl a variable"
+    echo "  m4_pattern_allow([^gl_LTLIBOBJS\$])dnl a variable"
     echo "  AC_REQUIRE([AC_PROG_RANLIB])"
     if grep AC_GNU_SOURCE "$destdir"/$m4base/*.m4 >/dev/null 2>/dev/null; then
       echo "  AC_REQUIRE([AC_GNU_SOURCE])"
@@ -1811,11 +1946,17 @@ func_import ()
     echo "# \"Check for header files, types and library functions\"."
     echo "AC_DEFUN([${macro_prefix}_INIT],"
     echo "["
+    func_emit_initmacro_start
     if test "$libtool" = true; then
       echo "  AM_CONDITIONAL([GL_COND_LIBTOOL], [true])"
+      echo "  gl_cond_libtool=true"
     else
       echo "  AM_CONDITIONAL([GL_COND_LIBTOOL], [false])"
+      echo "  gl_cond_libtool=false"
+      echo "  gl_libdeps="
+      echo "  gl_ltlibdeps="
     fi
+    echo "  gl_source_base='$sourcebase'"
     if test "$auxdir" != "build-aux"; then
       sed_replace_build_aux='
         :a
@@ -1842,7 +1983,18 @@ func_import ()
         fi
       fi
     done
+    # _LIBDEPS and _LTLIBDEPS variables are not needed if this library is
+    # created using libtool, because libtool already handles the dependencies.
+    if test "$libtool" != true; then
+      libname_upper=`echo "$libname" | tr 'a-z' 'A-Z'`
+      echo "  ${libname_upper}_LIBDEPS=\"\$gl_libdeps\""
+      echo "  AC_SUBST([${libname_upper}_LIBDEPS])"
+      echo "  ${libname_upper}_LTLIBDEPS=\"\$gl_ltlibdeps\""
+      echo "  AC_SUBST([${libname_upper}_LTLIBDEPS])"
+    fi
+    func_emit_initmacro_end
     echo "])"
+    func_emit_initmacro_done
     echo
     echo "# This macro records the list of files which have been installed by"
     echo "# gnulib-tool and may be removed by future gnulib-tool invocations."
@@ -1910,30 +2062,28 @@ func_import ()
   echo "Finished."
   echo
   echo "You may need to add #include directives for the following .h files."
+  # First the #include <...> directives without #ifs, sorted for convenience,
+  # then the #include "..." directives without #ifs, sorted for convenience,
+  # then the #include directives that are surrounded by #ifs. Not sorted.
+  for module in $modules; do
+    include_directive=`func_get_include_directive "$module"`
+    case "$nl$include_directive" in
+      *"$nl#if"*)
+        echo "$include_directive" 1>&5
+        ;;
+      *)
+        echo "$include_directive" | grep -v 'include "' 1>&6
+        echo "$include_directive" | grep 'include "' 1>&7
+        ;;
+    esac
+  done 5> "$tmp"/include-if 6> "$tmp"/include-angles 7> "$tmp"/include-quotes
   (
-   # First the #include <...> directives without #ifs, sorted for convenience.
-   for module in $modules; do
-     if func_get_include_directive "$module" | grep '^#if' >/dev/null; then
-       :
-     else
-       func_get_include_directive "$module" | grep -v 'include "'
-     fi
-   done | LC_ALL=C sort -u
-   # Then the #include "..." directives without #ifs, sorted for convenience.
-   for module in $modules; do
-     if func_get_include_directive "$module" | grep '^#if' >/dev/null; then
-       :
-     else
-       func_get_include_directive "$module" | grep 'include "'
-     fi
-   done | LC_ALL=C sort -u
-   # Then the #include directives that are surrounded by #ifs. Not sorted.
-   for module in $modules; do
-     if func_get_include_directive "$module" | grep '^#if' >/dev/null; then
-       func_get_include_directive "$module"
-     fi
-   done
-  ) | sed -e '/^$/d;' -e 's/^/  /'
+   LC_ALL=C sort -u "$tmp"/include-angles
+   LC_ALL=C sort -u "$tmp"/include-quotes
+   cat "$tmp"/include-if
+  ) | sed -e '/^$/d' -e 's/^/  /'
+  rm -f "$tmp"/include-angles "$tmp"/include-quotes "$tmp"/include-if
+
   echo
   echo "Don't forget to"
   if test "$makefile_am" = Makefile.am; then
@@ -1973,12 +2123,21 @@ func_create_testdir ()
 {
   testdir="$1"
   modules="$2"
-  modules=`for m in $modules; do echo $m; done | LC_ALL=C sort | LC_ALL=C uniq`
+  if test -z "$modules"; then
+    # All modules together.
+    # Except config-h, which breaks all modules which use HAVE_CONFIG_H.
+    # Except fnmatch-posix, which conflicts with fnmatch-gnu. FIXME.
+    modules=`func_all_modules`
+    modules=`for m in $modules; do if test $m != config-h && test $m != fnmatch-posix; then echo $m; fi; done`
+  fi
+  modules=`for m in $modules; do echo $m; done | LC_ALL=C sort -u`
 
   # Subdirectory names.
   sourcebase=gllib
   m4base=glm4
+  docbase=gldoc
   testsbase=gltests
+  macro_prefix=gl
 
   # Determine final module list.
   func_modules_transitive_closure
@@ -1997,6 +2156,7 @@ func_create_testdir ()
   for d in `echo "$files" | sed -n -e 's,^\(.*\)/[^/]*,\1,p'`; do
     case "$d" in
       build-aux) mkdir -p "$testdir/$auxdir" ;;
+      doc)       mkdir -p "$testdir/$docbase" ;;
       lib)       mkdir -p "$testdir/$sourcebase" ;;
       m4)        mkdir -p "$testdir/$m4base" ;;
       tests)     mkdir -p "$testdir/$testsbase" ;;
@@ -2005,26 +2165,35 @@ func_create_testdir ()
   done
 
   # Copy files or make symbolic links.
-  for f in $files; do
-    func_lookup_file "$f"
-    case "$f" in
-      build-aux/*) g=`echo "$f" | sed -e "s,^build-aux/,$auxdir/,"` ;;
-      lib/*) g=`echo "$f" | sed -e "s,^lib/,$sourcebase/,"` ;;
-      m4/*) g=`echo "$f" | sed -e "s,^m4/,$m4base/,"` ;;
-      tests/*) g=`echo "$f" | sed -e "s,^tests/,$testsbase/,"` ;;
-      *) g="$f" ;;
-    esac
-    if test -n "$lookedup_tmp"; then
-      cp -p "$lookedup_file" "$testdir/$g"
-    else
-      ln "$lookedup_file" "$testdir/$g" 2>/dev/null ||
-      if test -z "$symbolic"; then
+  delimiter='  '
+  sed_rewrite_files="\
+    s,^build-aux/,$auxdir/,
+    s,^doc/,$docbase/,
+    s,^lib/,$sourcebase/,
+    s,^m4/,$m4base/,
+    s,^tests/,$testsbase/,"
+  for f in $files; do echo $f; done \
+    | sed -e "s,^.*\$,&$delimiter&," -e "$sed_rewrite_files" \
+    | LC_ALL=C sort \
+    > "$tmp"/files
+  { # Rearrange file descriptors. Needed because "while ... done < ..."
+    # constructs are executed in a subshell e.g. by Solaris 10 /bin/sh.
+    exec 5<&0 < "$tmp"/files
+    while read g f; do
+      func_lookup_file "$f"
+      if test -n "$lookedup_tmp"; then
         cp -p "$lookedup_file" "$testdir/$g"
       else
-        ln -s "$lookedup_file" "$testdir/$g"
+        ln "$lookedup_file" "$testdir/$g" 2>/dev/null ||
+        if test -z "$symbolic"; then
+          cp -p "$lookedup_file" "$testdir/$g"
+        else
+          ln -s "$lookedup_file" "$testdir/$g"
+        fi
       fi
-    fi
-  done
+    done
+    exec 0<&5 5<&-
+  }
 
   # Create $sourcebase/Makefile.am.
   mkdir -p "$testdir/$sourcebase"
@@ -2046,13 +2215,13 @@ func_create_testdir ()
   subdirs="$sourcebase $m4base"
   subdirs_with_configure_ac=""
 
-  if test -f "$testdir"/$m4base/gettext.m4; then
+  if false && test -f "$testdir"/$m4base/gettext.m4; then
     # Avoid stupid error message from automake:
     # "AM_GNU_GETTEXT used but `po' not in SUBDIRS"
     mkdir -p "$testdir/po"
     (echo "## Process this file with automake to produce Makefile.in."
     ) > "$testdir/po/Makefile.am"
-    subdirs="$subdirs po"
+    func_append subdirs " po"
   fi
 
   if test -n "$inctests"; then
@@ -2086,9 +2255,14 @@ func_create_testdir ()
      fi
      if test "$libtool" = true; then
        echo "AM_CONDITIONAL([GL_COND_LIBTOOL], [true])"
+       echo "gl_cond_libtool=true"
      else
        echo "AM_CONDITIONAL([GL_COND_LIBTOOL], [false])"
+       echo "gl_cond_libtool=false"
+       echo "gl_libdeps="
+       echo "gl_ltlibdeps="
      fi
+     echo "gl_source_base='$testsbase'"
      # Wrap the set of autoconf snippets into an autoconf macro that is then
      # invoked. This is needed because autoconf does not support AC_REQUIRE
      # at the top level:
@@ -2097,6 +2271,7 @@ func_create_testdir ()
      # expansion of the required macro before the current point, and only one
      # expansion total).
      echo "AC_DEFUN([gl_INIT], ["
+     func_emit_initmacro_start
      if test "$auxdir" != "build-aux"; then
        sed_replace_build_aux='
          :a
@@ -2125,7 +2300,19 @@ func_create_testdir ()
            | sed -e "$sed_replace_build_aux"
        fi
      done
+     # _LIBDEPS and _LTLIBDEPS variables are not needed if this library is
+     # created using libtool, because libtool already handles the dependencies.
+     if test "$libtool" != true; then
+       libname_upper=`echo "$libname" | tr 'a-z' 'A-Z'`
+       echo "  ${libname_upper}_LIBDEPS=\"\$gl_libdeps\""
+       echo "  AC_SUBST([${libname_upper}_LIBDEPS])"
+       echo "  ${libname_upper}_LTLIBDEPS=\"\$gl_ltlibdeps\""
+       echo "  AC_SUBST([${libname_upper}_LTLIBDEPS])"
+     fi
+     func_emit_initmacro_end
      echo "])"
+     func_emit_initmacro_done
+     echo
      echo "gl_INIT"
      echo
      # Usually $testsbase/config.h will be a superset of config.h. Verify this
@@ -2134,7 +2321,7 @@ func_create_testdir ()
      echo
      echo "AC_OUTPUT([Makefile])"
     ) > "$testdir/$testsbase/configure.ac"
-    subdirs="$subdirs $testsbase"
+    func_append subdirs " $testsbase"
     subdirs_with_configure_ac="$subdirs_with_configure_ac $testsbase"
   fi
 
@@ -2163,7 +2350,9 @@ func_create_testdir ()
    echo "AC_PROG_MAKE_SET"
    echo
    echo "m4_pattern_forbid([^gl_[A-Z]])dnl the gnulib macro namespace"
-   echo "m4_pattern_allow([^gl_ES$])dnl a valid locale name"
+   echo "m4_pattern_allow([^gl_ES\$])dnl a valid locale name"
+   echo "m4_pattern_allow([^gl_LIBOBJS\$])dnl a variable"
+   echo "m4_pattern_allow([^gl_LTLIBOBJS\$])dnl a variable"
    echo
    echo "AC_PROG_RANLIB"
    echo
@@ -2181,9 +2370,14 @@ func_create_testdir ()
    fi
    if test "$libtool" = true; then
      echo "AM_CONDITIONAL([GL_COND_LIBTOOL], [true])"
+     echo "gl_cond_libtool=true"
    else
      echo "AM_CONDITIONAL([GL_COND_LIBTOOL], [false])"
+     echo "gl_cond_libtool=false"
+     echo "gl_libdeps="
+     echo "gl_ltlibdeps="
    fi
+   echo "gl_source_base='$sourcebase'"
    # Wrap the set of autoconf snippets into an autoconf macro that is then
    # invoked. This is needed because autoconf does not support AC_REQUIRE
    # at the top level:
@@ -2192,6 +2386,7 @@ func_create_testdir ()
    # expansion of the required macro before the current point, and only one
    # expansion total).
    echo "AC_DEFUN([gl_INIT], ["
+   func_emit_initmacro_start
    if test "$auxdir" != "build-aux"; then
      sed_replace_build_aux='
        :a
@@ -2210,7 +2405,19 @@ func_create_testdir ()
          | sed -e "$sed_replace_build_aux"
      fi
    done
+   # _LIBDEPS and _LTLIBDEPS variables are not needed if this library is
+   # created using libtool, because libtool already handles the dependencies.
+   if test "$libtool" != true; then
+     libname_upper=`echo "$libname" | tr 'a-z' 'A-Z'`
+     echo "  ${libname_upper}_LIBDEPS=\"\$gl_libdeps\""
+     echo "  AC_SUBST([${libname_upper}_LIBDEPS])"
+     echo "  ${libname_upper}_LTLIBDEPS=\"\$gl_ltlibdeps\""
+     echo "  AC_SUBST([${libname_upper}_LTLIBDEPS])"
+   fi
+   func_emit_initmacro_end
    echo "])"
+   func_emit_initmacro_done
+   echo
    echo "gl_INIT"
    echo
    if test -n "$subdirs_with_configure_ac"; then
@@ -2222,7 +2429,7 @@ func_create_testdir ()
      # configure.ac which creates the subdir's Makefile.am, not this one.
      case " $subdirs_with_configure_ac " in
        *" $d "*) ;;
-       *) makefiles="$makefiles $d/Makefile" ;;
+       *) func_append makefiles " $d/Makefile" ;;
      esac
    done
    echo "AC_OUTPUT([$makefiles])"
@@ -2230,8 +2437,27 @@ func_create_testdir ()
 
   # Create autogenerated files.
   (cd "$testdir"
-   echo "executing ${AUTORECONF} --force --install"
-   ${AUTORECONF} --force --install
+   # Do not use "${AUTORECONF} --force --install", because it may invoke
+   # autopoint, which brings in older versions of some of our .m4 files.
+   if test -f $m4base/gettext.m4; then
+     echo "executing ${AUTOPOINT} --force"
+     ${AUTOPOINT} --force
+     for f in $m4base/*.m4~; do
+       mv $f `echo $f | sed -e 's,~$,,'`
+     done
+   fi
+   echo "executing ${ACLOCAL} --force -I $m4base"
+   ${ACLOCAL} --force -I $m4base
+   if ! test -d build-aux; then
+     echo "executing mkdir build-aux"
+     mkdir build-aux
+   fi
+   echo "executing ${AUTOCONF} --force"
+   ${AUTOCONF} --force
+   echo "executing ${AUTOHEADER} --force"
+   ${AUTOHEADER} --force
+   echo "executing ${AUTOMAKE} --add-missing --copy --force-missing"
+   ${AUTOMAKE} --add-missing --copy --force-missing
   )
   if grep '^BUILT_SOURCES *+=' "$testdir/$sourcebase/Makefile.am" > /dev/null; then
     (cd "$testdir"
@@ -2261,13 +2487,14 @@ func_create_megatestdir ()
   # First, all modules one by one.
   for onemodule in $allmodules; do
     func_create_testdir "$megatestdir/$onemodule" $onemodule
-    megasubdirs="${megasubdirs}$onemodule "
+    func_append megasubdirs "$onemodule "
   done
   # Then, all modules all together.
+  # Except config-h, which breaks all modules which use HAVE_CONFIG_H.
   # Except fnmatch-posix, which conflicts with fnmatch-gnu. FIXME.
-  allmodules=`for m in $allmodules; do if test $m != fnmatch-posix; then echo $m; fi; done`
+  allmodules=`for m in $allmodules; do if test $m != config-h && test $m != fnmatch-posix; then echo $m; fi; done`
   func_create_testdir "$megatestdir/ALL" "$allmodules"
-  megasubdirs="${megasubdirs}ALL"
+  func_append megasubdirs "ALL"
 
   # Create Makefile.am.
   (echo "## Process this file with automake to produce Makefile.in."
@@ -2384,7 +2611,7 @@ case $mode in
               /*) ;;
               *)
                 if test -f "$destdir/$arg"/gnulib-cache.m4; then
-                  m4dirs="$m4dirs $arg"
+                  func_append m4dirs " $arg"
                   m4dirs_count=`expr $m4dirs_count + 1`
                 fi
                 ;;
@@ -2403,7 +2630,7 @@ case $mode in
           sedexpr1='s,^m4_include(\[\(.*\)])$,\1,p'
           sedexpr2='s,^[^/]*$,.,'
           sedexpr3='s,/[^/]*$,,'
-          m4dirs=`sed -n -e "$sedexpr1" aclocal.m4 | sed -e "$sedexpr2" -e "$sedexpr3" | LC_ALL=C sort | LC_ALL=C uniq`
+          m4dirs=`sed -n -e "$sedexpr1" aclocal.m4 | sed -e "$sedexpr2" -e "$sedexpr3" | LC_ALL=C sort -u`
           m4dirs_count=`echo "$m4dirs" | wc -l`
         fi
       fi
@@ -2434,7 +2661,7 @@ case $mode in
               #   local_gnulib_dir, avoidlist, sourcebase, m4base, docbase,
               #   testsbase, libname, lgpl, makefile_name, libtool, macro_prefix
               # don't propagate from one directory to another.
-              (func_import) || exit 1
+              (func_import) || func_exit 1
             done
           else
             # Really ambiguous.
@@ -2481,7 +2708,7 @@ case $mode in
         if test -n "$remaining"; then
           echo "Remaining files:" $remaining 1>&2
           echo "gnulib-tool: *** Stop." 1>&2
-          exit 1
+          func_exit 1
         fi
       cd ..
     cd ..
@@ -2504,7 +2731,7 @@ case $mode in
         if test -n "$remaining"; then
           echo "Remaining files:" $remaining 1>&2
           echo "gnulib-tool: *** Stop." 1>&2
-          exit 1
+          func_exit 1
         fi
       cd ..
     cd ..
@@ -2607,12 +2834,12 @@ esac
 
 rm -rf "$tmp"
 # Undo the effect of the previous 'trap' command. Some shellology:
-# We cannot use "trap - 0 1 2 3 15", because Solaris sh would attempt to
+# We cannot use "trap - 0 1 2 3 13 15", because Solaris sh would attempt to
 # execute the command "-". "trap '' ..." is fine only for signal 0 (= normal
 # exit); for the others we need to call 'exit' explicitly. The value of $? is
 # 128 + signal number and is set before the trap-registered command is run.
 trap '' 0
-trap 'exit $?' 1 2 3 15
+trap 'func_exit $?' 1 2 3 13 15
 
 exit 0